# Create Streaming Endpoint

put ` https://app.mk.io/api/v1/projects/:project_name/media/streamingEndpoints/:endpoint_name`

Create a Streaming Endpoint.

RBAC Capability Required: `ams.streamingendpoint.create`

## Authentication

Authorization Bearer

Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Path parameters

- **project_name** string Required
- **endpoint_name** string Required

## Request

This endpoint expects an object.

- **location** string Required
  The name of the location in which the streaming endpoint is located. This field must match the location in which the user's subscription is provisioned.
- **properties** object [StreamingEndpointPutProperties](https://docs.mediakind.com/api-reference/media-api/schemas/streamingendpointputproperties) Required

### Show 17 properties
- **accessControl** object [StreamingEndpointAccessControl](https://docs.mediakind.com/api-reference/media-api/schemas/streamingendpointaccesscontrol) Optional
- **akamai** object [StreamingEndpointAkamiACL](https://docs.mediakind.com/api-reference/media-api/schemas/streamingendpointakamiacl) Optional Deprecated
  DEPRECATED: This is provided for backwards compatibility and will be removed in a future release.
- **akamaiSignatureHeaderAuthenticationKeyList** list of objects [AkamiHeaderAuthKey](https://docs.mediakind.com/api-reference/media-api/schemas/akamiheaderauthkey) Required Deprecated
- **ip** object [StreamingEndpointIPACL](https://docs.mediakind.com/api-reference/media-api/schemas/streamingendpointipacl) Optional
  IP-based access control configuration for the streaming endpoint. If omitted, this will default to 0.0.0.0/0
  - **allow** list of objects [IPAcl](https://docs.mediakind.com/api-reference/media-api/schemas/ipacl) Required
    - **address** string Required
    - **name** string Optional Defaults to
    - **subnetPrefixLength** integer Optional 0 to 32 Defaults to 32
- **advancedSettingsName** string or null Optional <=64 characters
- **cdnEnabled** boolean Optional Defaults to false
- **cdnProfile** string Optional <=100 characters
- **cdnProvider** enum Optional Deprecated
  Allowed values: Standard, Akamai
- **crossSiteAccessPolicies** object [CrossSiteAccessPolicies](https://docs.mediakind.com/api-reference/media-api/schemas/crosssiteaccesspolicies) Optional
  - **clientAccessPolicy** string or null Optional
  - **crossDomainPolicy** string or null Optional
- **customHostNames** list of strings Optional
- **description** string or null Optional <=1024 characters
- **maxCacheAge** integer Optional 0 to 2592000 Defaults to 86400
- **maxManifestCacheAge** integer Optional 0 to 2592000 Defaults to 60
- **provisioningState** enum Optional
  Allowed values: InProgress, Succeeded, Failed
- **publicName** string Optional 3-63 characters pattern: ^[a-z0-9]+(-[a-z0-9]+)*$
- **resourceState** enum Optional
  Allowed values: Creating, Updating, Scaling, Starting, Stopping, Restarting, Deleting, Running, Stopped, Deleted
- **scaleUnits** integer Required >=0

### Shield Cache
- **shieldCache** object [StreamingEndpointShieldCache](https://docs.mediakind.com/api-reference/media-api/schemas/streamingendpointshieldcache) Optional
- **sku** object [StreamingEndpointPutPropertiessCurrentSku](https://docs.mediakind.com/api-reference/media-api/schemas/streamingendpointputpropertiesscurrentsku) Optional
  - **name** enum Required
    Allowed values: Standard, Premium

## Response

201 The created Streaming Endpoint

- **location** string Required
- **name** string Optional 1-64 characters pattern: ^[a-zA-Z0-9]+(-[a-zA-Z0-9])*$
- **properties** object [StreamingEndpointProperties](https://docs.mediakind.com/api-reference/media-api/schemas/streamingendpointproperties) Required

### Show 21 properties

- **error** object [ErrorDetail](https://docs.mediakind.com/api-reference/media-api/schemas/errordetail) Required
  - **code** string Required
  - **detail** string Required
  - **extraDetail** map from strings to any Optional

## Errors

- **400** Bad Request
- **401** Unauthorized
- **403** Forbidden
- **404** Not Found
- **409** Conflict
- **429** Too Many Requests
- **500** Internal Server Error
